import React, { useState, useEffect, useRef, useCallback } from 'react';

function useTextNode(text) {
  const ref = useRef({
    text: null
  });
  ref.current.text = text;
  const Text = useCallback(() => {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    const [text, setText] = useState(ref.current.text);
    ref.current.setText = setText;
    return text;
  }, []);
  useEffect(() => {
    if (ref.current.setText) ref.current.setText(text);
  }, [text]);
  return React.createElement(Text, {});
}

export default useTextNode;