"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

/**
 * Similar to useMemo, with a few subtle differences:
 * - The factory function has a argument which is the result of the previous call to the factory function
 */
function useMemoWithArgument(factory, deps) {
  var ref = (0, _react.useRef)({
    result: undefined,
    deps: undefined,
    extra: {}
  });
  return (0, _react.useMemo)(function () {
    var result = factory(ref.current.result, ref.current.deps, ref.current.extra);
    ref.current.result = result;
    ref.current.deps = deps;
    return result; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, deps);
}

var _default = useMemoWithArgument;
exports.default = _default;
//# sourceMappingURL=use-memo-with-argument.js.map