"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.array.from.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.promise.js");

var _react = require("react");

var _useEvent = _interopRequireDefault(require("./use-event"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function refsInitialState() {
  return {
    proms: []
  };
}
/**
 * Similar to useState, with a few subtle differences:
 * - The returned function is a promise that will resolve when FC is recalled and the state is same with the update value;
 */


function useStateWithPromise(initialState) {
  var _useState = (0, _react.useState)(initialState),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var _useState3 = (0, _react.useState)(refsInitialState),
      _useState4 = _slicedToArray(_useState3, 1),
      $refs = _useState4[0];

  (0, _react.useMemo)(function () {
    if (!$refs.proms.length) return;
    var proms = $refs.proms.splice(0, $refs.proms.length);
    proms.forEach(function (prom) {
      if (prom.options.alwaysResolve || prom.nextState === state) {
        prom.resolve(state);
      } else if (process.env.NODE_ENV !== 'production') {
        console.error('[useStateWithPromise warning]: the state has been updated, but its value is different from the updated value', {
          state: state,
          updateState: prom.nextState
        });
      }
    });
  }, [$refs, state]);
  var setStateWithPromise = (0, _useEvent.default)(function (stateAction) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var prom = {
      options: options
    };
    var ret = new Promise(function (resolve, reject) {
      prom.resolve = resolve;
      prom.reject = reject;
    });

    if (typeof stateAction === 'function') {
      setState(function (prevState) {
        prom.nextState = stateAction(prevState);
        if (prevState === prom.nextState) prom.resolve(prevState);else $refs.proms.push(prom);
        return prom.nextState;
      });
    } else {
      if (stateAction === state) prom.resolve(state);else {
        $refs.proms.push(prom);
        setState(prom.nextState = stateAction);
      }
    }

    return ret;
  });
  return [state, setStateWithPromise];
}

var _default = useStateWithPromise;
exports.default = _default;
//# sourceMappingURL=use-state-with-promise.js.map